// Copyright 2006 Google Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// Known Issues:
//
// * Patterns are not implemented.
// * Radial gradient are not implemented. The VML version of these look very
//   different from the canvas one.
// * Clipping paths are not implemented.
// * Coordsize. The width and height attribute have higher priority than the
//   width and height style values which isn't correct.
// * Painting mode isn't implemented.
// * Canvas width/height should is using content-box by default. IE in
//   Quirks mode will draw the canvas using border-box. Either change your
//   doctype to HTML5
//   (http://www.whatwg.org/specs/web-apps/current-work/#the-doctype)
//   or use Box Sizing Behavior from WebFX
//   (http://webfx.eae.net/dhtml/boxsizing/boxsizing.html)
// * Optimize. There is always room for speed improvements.
// only add this code if we do not already have a canvas implementation
window.CanvasRenderingContext2D||function(){function u(){}function t(a){this.type_=a,this.radius1_=0,this.radius2_=0,this.colors_=[],this.focus_={x:0,y:0}}function r(a){this.m_=m(),this.mStack_=[],this.aStack_=[],this.currentPath_=[],this.strokeStyle="#000",this.fillStyle="#000",this.lineWidth=1,this.lineJoin="miter",this.lineCap="butt",this.miterLimit=e*1,this.globalAlpha=1,this.canvas=a;var b=a.ownerDocument.createElement("div");b.style.width=a.clientWidth+"px",b.style.height=a.clientHeight+"px",b.style.overflow="hidden",b.style.position="absolute",a.appendChild(b),this.element_=b,this.arcScaleX_=1,this.arcScaleY_=1}function q(a){switch(a){case"butt":return"flat";case"round":return"round";case"square":default:return"square"}}function p(a){var b,c=1;a=String(a);if(a.substring(0,3)=="rgb"){var d=a.indexOf("(",3),e=a.indexOf(")",d+1),f=a.substring(d+1,e).split(",");b="#";for(var g=0;g<3;g++)b+=j[Number(f[g])];f.length==4&&a.substr(3,1)=="a"&&(c=f[3])}else b=a;return[b,c]}function o(a,b){b.fillStyle=a.fillStyle,b.lineCap=a.lineCap,b.lineJoin=a.lineJoin,b.lineWidth=a.lineWidth,b.miterLimit=a.miterLimit,b.shadowBlur=a.shadowBlur,b.shadowColor=a.shadowColor,b.shadowOffsetX=a.shadowOffsetX,b.shadowOffsetY=a.shadowOffsetY,b.strokeStyle=a.strokeStyle,b.arcScaleX_=a.arcScaleX_,b.arcScaleY_=a.arcScaleY_}function n(a,b){var c=m();for(var d=0;d<3;d++)for(var e=0;e<3;e++){var f=0;for(var g=0;g<3;g++)f+=a[d][g]*b[g][e];c[d][e]=f}return c}function m(){return[[1,0,0],[0,1,0],[0,0,1]]}function i(a){var b=a.srcElement;b.firstChild&&(b.firstChild.style.width=b.clientWidth+"px",b.firstChild.style.height=b.clientHeight+"px")}function h(a){var b=a.srcElement;switch(a.propertyName){case"width":b.style.width=b.attributes.width.nodeValue+"px",b.getContext().clearRect();break;case"height":b.style.height=b.attributes.height.nodeValue+"px",b.getContext().clearRect()}}var a=Math,b=a.round,c=a.sin,d=a.cos,e=10,f=e/2,g={init:function(a){var b=a||document;if(/MSIE/.test(navigator.userAgent)&&!window.opera){var c=this;b.attachEvent("onreadystatechange",function(){c.init_(b)})}},init_:function(a){if(a.readyState=="complete"){a.namespaces.g_vml_||a.namespaces.add("g_vml_","urn:schemas-microsoft-com:vml");var b=a.createStyleSheet();b.cssText="canvas{display:inline-block;overflow:hidden;text-align:left;width:300px;height:150px}g_vml_\\:*{behavior:url(#default#VML)}";var c=a.getElementsByTagName("canvas");for(var d=0;d<c.length;d++)c[d].getContext||this.initElement(c[d])}},fixElement_:function(a){var b=a.outerHTML,c=a.ownerDocument.createElement(b);if(b.slice(-2)!="/>"){var d="/"+a.tagName,e;while((e=a.nextSibling)&&e.tagName!=d)e.removeNode();e&&e.removeNode()}a.parentNode.replaceChild(c,a);return c},initElement:function(a){a=this.fixElement_(a),a.getContext=function(){if(this.context_)return this.context_;return this.context_=new r(this)},a.attachEvent("onpropertychange",h),a.attachEvent("onresize",i);var b=a.attributes;b.width&&b.width.specified?a.style.width=b.width.nodeValue+"px":a.width=a.clientWidth,b.height&&b.height.specified?a.style.height=b.height.nodeValue+"px":a.height=a.clientHeight;return a}};g.init();var j=[];for(var k=0;k<16;k++)for(var l=0;l<16;l++)j[k*16+l]=k.toString(16)+l.toString(16);var s=r.prototype;s.clearRect=function(){this.element_.innerHTML="",this.currentPath_=[]},s.beginPath=function(){this.currentPath_=[]},s.moveTo=function(a,b){this.currentPath_.push({type:"moveTo",x:a,y:b}),this.currentX_=a,this.currentY_=b},s.lineTo=function(a,b){this.currentPath_.push({type:"lineTo",x:a,y:b}),this.currentX_=a,this.currentY_=b},s.bezierCurveTo=function(a,b,c,d,e,f){this.currentPath_.push({type:"bezierCurveTo",cp1x:a,cp1y:b,cp2x:c,cp2y:d,x:e,y:f}),this.currentX_=e,this.currentY_=f},s.quadraticCurveTo=function(a,b,c,d){var e=this.currentX_+2/3*(a-this.currentX_),f=this.currentY_+2/3*(b-this.currentY_),g=e+(c-this.currentX_)/3,h=f+(d-this.currentY_)/3;this.bezierCurveTo(e,f,g,h,c,d)},s.arc=function(a,b,g,h,i,j){g*=e;var k=j?"at":"wa",l=a+d(h)*g-f,m=b+c(h)*g-f,n=a+d(i)*g-f,o=b+c(i)*g-f;l==n&&!j&&(l+=.125),this.currentPath_.push({type:k,x:a,y:b,radius:g,xStart:l,yStart:m,xEnd:n,yEnd:o})},s.rect=function(a,b,c,d){this.moveTo(a,b),this.lineTo(a+c,b),this.lineTo(a+c,b+d),this.lineTo(a,b+d),this.closePath()},s.strokeRect=function(a,b,c,d){this.beginPath(),this.moveTo(a,b),this.lineTo(a+c,b),this.lineTo(a+c,b+d),this.lineTo(a,b+d),this.closePath(),this.stroke()},s.fillRect=function(a,b,c,d){this.beginPath(),this.moveTo(a,b),this.lineTo(a+c,b),this.lineTo(a+c,b+d),this.lineTo(a,b+d),this.closePath(),this.fill()},s.createLinearGradient=function(a,b,c,d){var e=new t("gradient");return e},s.createRadialGradient=function(a,b,c,d,e,f){var g=new t("gradientradial");g.radius1_=c,g.radius2_=f,g.focus_.x=a,g.focus_.y=b;return g},s.drawImage=function(a,c){var d,f,g,h,i,j,k,l,m=a.runtimeStyle.width,n=a.runtimeStyle.height;a.runtimeStyle.width="auto",a.runtimeStyle.height="auto";var o=a.width,p=a.height;a.runtimeStyle.width=m,a.runtimeStyle.height=n;if(arguments.length==3)d=arguments[1],f=arguments[2],i=j=0,k=g=o,l=h=p;else if(arguments.length==5)d=arguments[1],f=arguments[2],g=arguments[3],h=arguments[4],i=j=0,k=o,l=p;else if(arguments.length==9)i=arguments[1],j=arguments[2],k=arguments[3],l=arguments[4],d=arguments[5],f=arguments[6],g=arguments[7],h=arguments[8];else throw"Invalid number of arguments";var q=this.getCoords_(d,f),r=k/2,s=l/2,t=[],u=10,v=10;t.push(" <g_vml_:group",' coordsize="',e*u,",",e*v,'"',' coordorigin="0,0"',' style="width:',u,";height:",v,";position:absolute;");if(this.m_[0][0]!=1||this.m_[0][1]){var w=[];w.push("M11='",this.m_[0][0],"',","M12='",this.m_[1][0],"',","M21='",this.m_[0][1],"',","M22='",this.m_[1][1],"',","Dx='",b(q.x/e),"',","Dy='",b(q.y/e),"'");var x=q,y=this.getCoords_(d+g,f),z=this.getCoords_(d,f+h),A=this.getCoords_(d+g,f+h);x.x=Math.max(x.x,y.x,z.x,A.x),x.y=Math.max(x.y,y.y,z.y,A.y),t.push("padding:0 ",b(x.x/e),"px ",b(x.y/e),"px 0;filter:progid:DXImageTransform.Microsoft.Matrix(",w.join(""),", sizingmethod='clip');")}else t.push("top:",b(q.y/e),"px;left:",b(q.x/e),"px;");t.push(' ">','<g_vml_:image src="',a.src,'"',' style="width:',e*g,";"," height:",e*h,';"',' cropleft="',i/o,'"',' croptop="',j/p,'"',' cropright="',(o-i-k)/o,'"',' cropbottom="',(p-j-l)/p,'"'," />","</g_vml_:group>"),this.element_.insertAdjacentHTML("BeforeEnd",t.join(""))},s.stroke=function(a){var c=[],d=!1,f=p(a?this.fillStyle:this.strokeStyle),g=f[0],h=f[1]*this.globalAlpha,i=10,j=10;c.push("<g_vml_:shape",' fillcolor="',g,'"',' filled="',Boolean(a),'"',' style="position:absolute;width:',i,";height:",j,';"',' coordorigin="0 0" coordsize="',e*i," ",e*j,'"',' stroked="',!a,'"',' strokeweight="',this.lineWidth,'"',' strokecolor="',g,'"',' path="');var k=!1,l={x:null,y:null},m={x:null,y:null};for(var n=0;n<this.currentPath_.length;n++){var o=this.currentPath_[n];if(o.type=="moveTo"){c.push(" m ");var r=this.getCoords_(o.x,o.y);c.push(b(r.x),",",b(r.y))}else if(o.type=="lineTo"){c.push(" l ");var r=this.getCoords_(o.x,o.y);c.push(b(r.x),",",b(r.y))}else if(o.type=="close")c.push(" x ");else if(o.type=="bezierCurveTo"){c.push(" c ");var r=this.getCoords_(o.x,o.y),s=this.getCoords_(o.cp1x,o.cp1y),t=this.getCoords_(o.cp2x,o.cp2y);c.push(b(s.x),",",b(s.y),",",b(t.x),",",b(t.y),",",b(r.x),",",b(r.y))}else if(o.type=="at"||o.type=="wa"){c.push(" ",o.type," ");var r=this.getCoords_(o.x,o.y),u=this.getCoords_(o.xStart,o.yStart),v=this.getCoords_(o.xEnd,o.yEnd);c.push(b(r.x-this.arcScaleX_*o.radius),",",b(r.y-this.arcScaleY_*o.radius)," ",b(r.x+this.arcScaleX_*o.radius),",",b(r.y+this.arcScaleY_*o.radius)," ",b(u.x),",",b(u.y)," ",b(v.x),",",b(v.y))}if(r){if(l.x==null||r.x<l.x)l.x=r.x;if(m.x==null||r.x>m.x)m.x=r.x;if(l.y==null||r.y<l.y)l.y=r.y;if(m.y==null||r.y>m.y)m.y=r.y}}c.push(' ">');if(typeof this.fillStyle=="object"){var w={x:"50%",y:"50%"},x=m.x-l.x,y=m.y-l.y,z=x>y?x:y;w.x=b(this.fillStyle.focus_.x/x*100+50)+"%",w.y=b(this.fillStyle.focus_.y/y*100+50)+"%";var A=[];if(this.fillStyle.type_=="gradientradial")var B=this.fillStyle.radius1_/z*100,C=this.fillStyle.radius2_/z*100-B;else var B=0,C=100;var D={offset:null,color:null},E={offset:null,color:null};this.fillStyle.colors_.sort(function(a,b){return a.offset-b.offset});for(var n=0;n<this.fillStyle.colors_.length;n++){var F=this.fillStyle.colors_[n];A.push(F.offset*C+B,"% ",F.color,",");if(F.offset>D.offset||D.offset==null)D.offset=F.offset,D.color=F.color;if(F.offset<E.offset||E.offset==null)E.offset=F.offset,E.color=F.color}A.pop(),c.push("<g_vml_:fill",' color="',E.color,'"',' color2="',D.color,'"',' type="',this.fillStyle.type_,'"',' focusposition="',w.x,", ",w.y,'"',' colors="',A.join(""),'"',' opacity="',h,'" />')}else a?c.push('<g_vml_:fill color="',g,'" opacity="',h,'" />'):c.push("<g_vml_:stroke",' opacity="',h,'"',' joinstyle="',this.lineJoin,'"',' miterlimit="',this.miterLimit,'"',' endcap="',q(this.lineCap),'"',' weight="',this.lineWidth,'px"',' color="',g,'" />');c.push("</g_vml_:shape>"),this.element_.insertAdjacentHTML("beforeEnd",c.join(""))},s.fill=function(){this.stroke(!0)},s.closePath=function(){this.currentPath_.push({type:"close"})},s.getCoords_=function(a,b){return{x:e*(a*this.m_[0][0]+b*this.m_[1][0]+this.m_[2][0])-f,y:e*(a*this.m_[0][1]+b*this.m_[1][1]+this.m_[2][1])-f}},s.save=function(){var a={};o(this,a),this.aStack_.push(a),this.mStack_.push(this.m_),this.m_=n(m(),this.m_)},s.restore=function(){o(this.aStack_.pop(),this),this.m_=this.mStack_.pop()},s.translate=function(a,b){var c=[[1,0,0],[0,1,0],[a,b,1]];this.m_=n(c,this.m_)},s.rotate=function(a){var b=d(a),e=c(a),f=[[b,e,0],[-e,b,0],[0,0,1]];this.m_=n(f,this.m_)},s.scale=function(a,b){this.arcScaleX_*=a,this.arcScaleY_*=b;var c=[[a,0,0],[0,b,0],[0,0,1]];this.m_=n(c,this.m_)},s.clip=function(){},s.arcTo=function(){},s.createPattern=function(){return new u},t.prototype.addColorStop=function(a,b){b=p(b),this.colors_.push({offset:1-a,color:b})},G_vmlCanvasManager=g,CanvasRenderingContext2D=r,CanvasGradient=t,CanvasPattern=u}()